//
// Author:
//   Leif Kornstaedt <kornstae@ps.uni-sb.de>
//
// Copyright:
//   Leif Kornstaedt, 2002
//
// Last Change:
//   $Date: 2004/02/09 16:55:59 $ by $Author: bruni $
//   $Revision: 1.12 $
//

#if defined(INTERFACE)
#pragma implementation "java/ClassInfo.hh"
#endif

#include "java/ClassInfo.hh"

u_int FieldInfo::GetNumberOfRequiredSlots() {
  JavaString *descriptor = GetDescriptor();
  switch (descriptor->CharAt(0)) {
  case 'B': case 'C': case 'F':
  case 'I': case 'S': case 'Z':
  case 'L': case '[':
    return 1;
  case 'J': case 'D':
    return 2;
  default:
    Error("invalid field descriptor");
  }
}

u_int MethodInfo::GetNumberOfArguments() {
  JavaString *descriptor = GetDescriptor();
  Assert(descriptor->CharAt(0) == '(');
  u_int index = 1;
  u_int nArgs = 0;
  while (descriptor->CharAt(index) != ')') {
    while (descriptor->CharAt(index) == '[') index++;
    switch (descriptor->CharAt(index)) {
    case 'B': case 'C': case 'F':
    case 'I': case 'S': case 'Z':
      index++;
      break;
    case 'J': case 'D':
      index++;
      nArgs++;
      break;
    case 'L':
      while (descriptor->CharAt(index++) != ';');
      break;
    default:
      Error("invalid method descriptor");
    }
    nArgs++;
  }
  return nArgs;
}

u_int MethodInfo::GetNumberOfReturnValues() {
  JavaString *descriptor = GetDescriptor();
  Assert(descriptor->CharAt(0) == '(');
  u_int index = 1;
  while (descriptor->CharAt(index) != ')')
    index++;
  index++;
  while (descriptor->CharAt(index) == '[') index++;
  switch (descriptor->CharAt(index)) {
  case 'B': case 'C': case 'F':
  case 'I': case 'S': case 'Z':
  case 'L':
    return 1;
  case 'J': case 'D':
    // TODO: Slots or value?
    return 1;
  case 'V':
    return 0;
  default:
    Error("invalid method descriptor");
  }
}

bool ClassInfo::Verify() {
  return true; //--** implement verifier
}
