//
// Authors:
//   Patrick Cernko <cernko@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/03/22 11:28:35 $ by $Author: errror $
//   $Revision: 1.2.2.1 $
//
#ifndef __JAVA__CONSTANT_POOL_ENTRY_HH__
#define __JAVA__CONSTANT_POOL_ENTRY_HH__

#if defined(INTERFACE)
#pragma interface "java/ConstantPoolEntry.hh"
#endif

#include "java/Data.hh"
#include "java/ConstantTag.hh"

class ConstantPool;
class ClassLoader;

//
// Symbolic Constant Pool Entries
//
class ConstantPoolEntry
  : private Block {
public:
  using Block::ToWord;
  using Block::InitArg;
  using Block::GetArg;

  static ConstantPoolEntry *New(CONSTANT_tag tag, u_int size) {
    return STATIC_CAST(ConstantPoolEntry *, (Store::AllocBlock(STATIC_CAST(BlockLabel, MIN_DATA_LABEL + tag), size)));
  }
  static ConstantPoolEntry *FromWordDirect(word x) {
    return STATIC_CAST(ConstantPoolEntry *, Store::DirectWordToBlock(x));
  }

  CONSTANT_tag GetTag() {
    return STATIC_CAST(CONSTANT_tag, GetLabel() - MIN_DATA_LABEL);
  }
  word Resolve(ConstantPool *constantPool, ClassLoader *classLoader);
};

#endif
