//
// Authors:
//   Patrick Cernko <cernko@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/03/16 07:53:28 $ by $Author: errror $
//   $Revision: 1.1.2.1 $
//
#ifndef __JAVA__CONSTANT_TAG_HH__
#define __JAVA__CONSTANT_TAG_HH__

#if defined(INTERFACE)
#pragma interface "java/ConstantTag.hh"
#endif

enum CONSTANT_tag {
  // Tags for constant pool entries as defined by the JVM specification
  CONSTANT_Class              = 7,
  CONSTANT_Fieldref           = 9,
  CONSTANT_Methodref          = 10,
  CONSTANT_InterfaceMethodref = 11,
  CONSTANT_String             = 8,
  CONSTANT_Integer            = 3,
  CONSTANT_Float              = 4,
  CONSTANT_Long               = 5,
  CONSTANT_Double             = 6,
  CONSTANT_NameAndType        = 12,
  CONSTANT_Utf8               = 1,
  // Tags for unusable constant pool entries
  CONSTANT_Long_unusable      = MAX_DATA_LABEL - 1,
  CONSTANT_Double_unusable    = MAX_DATA_LABEL
};

#endif
