//
// Author:
//   Leif Kornstaedt <kornstae@ps.uni-sb.de>
//
// Copyright:
//   Leif Kornstaedt, 2002
//
// Last Change:
//   $Date: 2004/09/06 12:52:08 $ by $Author: errror $
//   $Revision: 1.2.2.1 $
//

#include "java/Authoring.hh"

DEFINE1(dumpInteger) {
  DECLARE_INT(i, x0);
  std::fprintf(stderr, "%d", i);
  RETURN_VOID;
} END

DEFINE1(dumpObject) {
  Debug::Dump(x0);
  RETURN_VOID;
} END

DEFINE1(dumpString) {
  DECLARE_JAVA_STRING(string, x0);
  std::fprintf(stderr, "%s", string->ExportC());
  RETURN_VOID;
} END

DEFINE1(dumpExit) {
  DECLARE_INT(i, x0);
  std::fprintf(stderr, "EXIT: %d\n", i);
  std::exit(i);
  RETURN_VOID;
} END

void NativeMethodTable::Dump(JavaString *className) {
  Register(className, "dump", "(I)V", dumpInteger, 1, false);
  Register(className, "dump", "(Ljava/lang/Object;)V", dumpObject, 1, false);
  Register(className, "dump", "(Ljava/lang/String;)V", dumpString, 1, false);
  Register(className, "exit", "(I)V", dumpExit, 1, false);
}
