//
// Author:
//   Leif Kornstaedt <kornstae@ps.uni-sb.de>
//
// Copyright:
//   Leif Kornstaedt, 2002-2003
//
// Last Change:
//   $Date: 2004/03/15 09:53:59 $ by $Author: errror $
//   $Revision: 1.8.2.1 $
//

#if defined(INTERFACE)
#pragma implementation "java/JavaLanguageLayer.hh"
#endif

#include "java/ThrowWorker.hh"
#include "java/NativeMethodTable.hh"
#include "java/ClassLoader.hh"
#ifdef KAFFE_INTERPRETER
#  include "java/KaffeInterpreter.hh"
#else
#  include "java/ByteCodeInterpreter.hh"
#endif
#include "java/JavaLanguageLayer.hh"

void JavaLanguageLayer::Init() {
  ClassLoader::Init();
  PrimitiveType::Init();
  Class::Init();
  ClassObject::Init();
  JavaString::Init();
  ThrowWorker::Init();
  NativeMethodTable::Init();
#ifdef KAFFE_INTERPRETER
  KaffeInterpreter::Init();
#else
  ByteCodeInterpreter::Init();
#endif
}
