//
// Authors:
//   Patrick Cernko <cernko@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/09/06 13:00:57 $ by $Author: errror $
//   $Revision: 1.1.2.1 $
//
#ifndef __JAVA__KAFFE_ACCESSORS_HH__
#define __JAVA__KAFFE_ACCESSORS_HH__

#if defined(INTERFACE)
#pragma interface "java/KaffeAccessors.hh"
#endif


#define	check_local_int(l)	CHDBG (dprintf ("- local %d (pos: %p): int %d\n", (l), local(l), Store::DirectWordToInt(*(local(l))) ))
#define	check_local_long(l)	CHDBG (dprintf ("- local %d (pos: %p): long %lld\n", (l), local(l), JavaLong::FromWord(*(local_long(l)))->GetValue() ))
#define	check_local_float(l)	CHDBG (dprintf ("- local %d (pos: %p): float %g\n", (l), local(l), JavaFloat::FromWord(*(local_float(l)))->GetValue() ))
#define	check_local_double(l)	CHDBG (dprintf ("- local %d (pos: %p): double %g\n", (l), local(l), JavaDouble::FromWord(*(local_double(l)))->GetValue() ))
#define	check_local_ref(l)	CHDBG (dprintf ("- local %d (pos: %p): ref %p\n", (l), local(l), (void*) (*(local(l)) == null)?NULL:(*(local(l))) ))

#define	check_stack_int(l)	CHDBG (dprintf ("- stack %d (pos: %p): int %d\n", (l), stack(l), Store::DirectWordToInt(*(stack(l))) ))
#define	check_stack_long(l)	CHDBG (dprintf ("- stack %d (pos: %p): long %lld\n", (l), stack(l), JavaLong::FromWord(*(stack_long(l)))->GetValue() ))
#define	check_stack_float(l)	CHDBG (dprintf ("- stack %d (pos: %p): float %g\n", (l), stack(l), JavaFloat::FromWord(*(stack_float(l)))->GetValue() ))
#define	check_stack_double(l)	CHDBG (dprintf ("- stack %d (pos: %p): double %g\n", (l), stack(l), JavaDouble::FromWord(*(stack_double(l)))->GetValue() ))
#define	check_stack_ref(l)	CHDBG (dprintf ("- stack %d (pos: %p): ref %p\n", (l), stack(l), (void*) (*(stack(l)) == null)?NULL:(*(stack(l))) ))

#define	check_stack_array(l)		CHDBG (dprintf ("- stack %d (pos: %p): array * %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_intarray(l)		CHDBG (dprintf ("- stack %d (pos: %p): array int %p[%d]\n", \
(l), stack(l), (void *) (*(stack(l))), BaseArray::FromWord(*(stack(l)))->GetLength() ))
#define	check_stack_longarray(l)	CHDBG (dprintf ("- stack %d (pos: %p): array long %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_floatarray(l)	CHDBG (dprintf ("- stack %d (pos: %p): array float %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_doublearray(l)	CHDBG (dprintf ("- stack %d (pos: %p): array double %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_refarray(l)		CHDBG (dprintf ("- stack %d (pos: %p): array ref %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_bytearray(l)	CHDBG (dprintf ("- stack %d (pos: %p): array byte %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_chararray(l)	CHDBG (dprintf ("- stack %d (pos: %p): array char %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))
#define	check_stack_shortarray(l)	CHDBG (dprintf ("- stack %d (pos: %p): array short %p[%d]\n", \
(l), stack(l), (void *) stack(l), -1 /*(int) *(uint32*)(object_array_length+(char*)stack(l)->v.taddr)*/))

#define check_pc(l)		CHDBG (dprintf ("  ARG %d: %d\n", l, getpc(l)))
#define check_pc_wide(l)	CHDBG (dprintf ("  ARG %d: %d = %d + %d[WIDE]\n", l, getpc(l)+wide, getpc(l), wide))
#define check_pcidx(l)	CHDBG (dprintf ("  ARG %d-%d: %d\n", l, l+1, (int16)((getpc(l) << 8) | getpc(l+1))))
#define check_pcwidx(l)	CHDBG (dprintf ("  ARG %d-%d: %d\n", l, l+3, (int32)((getpc(l) << 24) | (getpc(l+1) << 16) | (getpc(l+2) << 8) | getpc(l+3))))












#define W2L(w) (JavaLong::FromWord(w)->GetValue())
#define L2W(l) (JavaLong::New(l)->ToWord())
#define W2I(w) (Store::DirectWordToInt(w))
#define I2W(i) (Store::IntToWord(i))
#define W2F(w) (JavaFloat::FromWord(w)->GetValue())
#define F2W(f) (JavaFloat::ToWord(f))
#define W2D(w) (JavaDouble::FromWord(w)->GetValue())
#define D2W(d) (JavaDouble::ToWord(d))


#define	move_long_const(t, c)			*(t) = L2W(c)
#define	add_long(t, f1, f2)			*(t) = L2W(W2L(f1) + W2L(f2))
#define	sub_long(t, f1, f2)			*(t) = L2W(W2L(f1) - W2L(f2))
#define	mul_long(t, f1, f2)			*(t) = L2W(W2L(f1) * W2L(f2))
#define div_long(t, f1, f2)			*(t) = L2W((((W2L(f1)) == (int)JLONG_MIN) && ((W2L(f2)) == -1)) ? JLONG_MIN : ((W2L(f1)) / (W2L(f2))))
#define rem_long(t, f1, f2)                     *(t) = L2W(((W2L(f2)) != -1) ? ((W2L(f1)) % (W2L(f2))) : 0)
#define	neg_long(t, f)				*(t) = L2W(-W2L(f))

#define	and_long(t, f1, f2)			*(t) = L2W(W2L(f1) & W2L(f2))
#define	or_long(t, f1, f2)			*(t) = L2W(W2L(f1) | W2L(f2))
#define	xor_long(t, f1, f2)			*(t) = L2W(W2L(f1) ^ W2L(f2))

#define	lshl_long(t, f1, f2)			*(t) = L2W(W2L(*(f1)) << (W2I(*(f2)) & 63))
#define	ashr_long(t, f1, f2)			*(t) = L2W(((int64)W2L(*(f1))) >> (W2I(*(f2)) & 63))
#define	lshr_long(t, f1, f2)			*(t) = L2W(((uint64)W2L(*(f1))) >> (W2I(*(f2)) & 63))

#define	lcmp(t, f1, f2)				do { jlong l2 = W2L(f2); jlong l1 = W2L(f1); \
						*(t) = I2W((l1 == l2)? 0 : ((l1 > l2) ? -1 : 1)); } while(0);

#define	cvt_int_long(t, f)			*(t) = L2W(W2I(*(f)))
#define	cvt_long_int(t, f)			*(t) = I2W(W2L(*(f)))
#define	cvt_long_float(t, f)			*(t) = F2W(W2L(*(f)))
#define	cvt_long_double(t, f)			*(t) = D2W(W2L(*(f)))
#define	cvt_float_long(t, f)			*(t) = L2W(soft_cvtfl(W2F(*(f))))
#define	cvt_double_long(t, f)			*(t) = L2W(soft_cvtdl(W2D(*(f))))


#define	move_int_const(t, c)			*(t) = I2W(c)
#define	move_ref_const(t, c)			*(t) = (c)
#define	move_label_const(t, c)			move_ref_const(t, Store::UnmanagedPointerToWord((void*)c))
#define	move_string_const(t, c)			move_ref_const(t, STATIC_CAST(word, c))

#define	move_int(t, f)				*(t) = *(f)
#define	move_ref(t, f)				*(t) = *(f)
#define	move_any(t, f)				move_long(t, f)

/* XXX: todo */
#define	swap_any(t1, t2)			/*{			\
						  tmp[0] = (t1)[0];	\
						  (t1)[0] = (t2)[0];	\
						  (t2)[0] = tmp[0];	\
                                                  }*/

#define	load_int(t, f)				(t)[0].v.tint = *(jint*)((f)[0].v.taddr)
#define	load_ref(t, f)				(t)[0].v.taddr = *(void**)((f)[0].v.taddr)
#define	load_byte(t, f)				(t)[0].v.tint = *(jbyte*)((f)[0].v.taddr)
#define	load_char(t, f)				(t)[0].v.tint = *(jchar*)((f)[0].v.taddr)

#define	store_int(t, f)				*(jint*)((t)[0].v.taddr) = (W2I(f))
#define	store_ref(t, f)				*(void**)((t)[0].v.taddr) = ((f)[0].v.taddr)
#define	store_byte(t, f)			*(jbyte*)((t)[0].v.taddr) = (W2I(f))
#define	store_char(t, f)			*(jchar*)((t)[0].v.taddr) = (W2I(f))

#define	load_any(t, f)				load_int(t, f)
/* XXX: todo */
#define load_offset_any(t, f, o)		/*load_offset_int(t, f, o)*/
#define	store_any(t, f)				store_int(t, f)
#define store_offset_any(t, f, o)		store_offset_int(t, f, o)

//#define	add_int_const(t, f, c)			*(t) = I2W(W2I(*(f)) + (c))
#define	add_int_const(t, f, c)			*(t) = (word)((int)(*(f)) + 2 * (c))
#define	add_ref_const(t, f, c)			*(t) = Store::UnmanagedPointerToWord((void*)((uint8*)(Store::WordToUnmanagedPointer(*(f))) + (c)))
//#define	sub_int_const(t, f, c)			*(t) = I2W(W2I(*(f)) - (c))
#define	sub_int_const(t, f, c)			*(t) = (word)((int)(*(f)) - 2 * (c))
//#define	mul_int_const(t, f, c)			*(t) = I2W(W2I(f) * (c))
#define	mul_int_const(t, f, c)			*(t) = (c) * ((f) - 1)

//#define	add_int(t, f1, f2)			*(t) = I2W(W2I(f1) + (W2I(f2)))
#define	add_int(t, f1, f2)			*(t) = (word)((int)(f1) + (int)(f2) - 1)
#define	add_ref(t, f1, f2)			*(t) = Store::UnmanagedPointerToWord((uint8*)(Store::WordToUnmanagedPointer(*(f1))) + (W2I(*(f2))))
//#define	sub_int(t, f1, f2)			*(t) = I2W(W2I(f1) - (W2I(f2)))
#define	sub_int(t, f1, f2)			*(t) = (word)((int)(f1) - (int)(f2) + 1)
//#define	mul_int(t, f1, f2)			mul_int_const(t, f1, (W2I(f2)))
#define	mul_int(t, f1, f2)			*(t) = (word)(((int)(f1) * (int)(f2) - (int)(f1) - (int)(f2) + 3) / 2)
#define div_int(t, f1, f2)			*(t) = I2W(((((W2I(f1)) == (int)JINT_MIN) && \
                                                           ((W2I(f2)) == -1)) ? JINT_MIN : \
                                                           (W2I(f1)) / (W2I(f2))))
#define rem_int(t, f1, f2)                      *(t) = I2W(((W2I(f2)) != -1) ? \
                                                            ((W2I(f1)) % (W2I(f2))) : 0)
#define	neg_int(t, f)				*(t) = I2W(-(W2I(f)))
#define	lshl_int_const(t, f, c)			*(t) = I2W(W2I(*(f)) << (c & 31))
#define	lshl_int(t, f1, f2)			*(t) = I2W(W2I(f1) << (W2I(f2) & 31))
#define	ashr_int(t, f1, f2)			*(t) = I2W(((int32) W2I(f1)) >> (W2I(f2) & 31))
#define	lshr_int(t, f1, f2)			*(t) = I2W(((uint32) W2I(f1)) >> (W2I(f2) & 31))
#define	and_int(t, f1, f2)			*(t) = I2W(W2I(f1) & W2I(f2))
#define	or_int(t, f1, f2)			*(t) = I2W(W2I(f1) | W2I(f2))
#define	xor_int(t, f1, f2)			*(t) = I2W(W2I(f1) ^ W2I(f2))

#define	cvt_int_byte(t, f)			*(t) = I2W((W2I(f) << 24) >> 24)
#define	cvt_int_char(t, f)			*(t) = I2W(W2I(f) & 0xFFFF)
#define	cvt_int_short(t, f)			*(t) = I2W((W2I(f) << 16) >> 16)

#define	branch_indirect(w)			w
#define	branch_a(w)				w

#define	cbranch_int_eq(s1, s2, w)		if (W2I(s1) == W2I(s2)) w
#define	cbranch_int_ne(s1, s2, w)		if (W2I(s1) != W2I(s2)) w
#define	cbranch_int_lt(s1, s2, w)		if (W2I(s1) < W2I(s2)) w
#define	cbranch_int_le(s1, s2, w)		if (W2I(s1) <= W2I(s2)) w
#define	cbranch_int_gt(s1, s2, w)		if (W2I(s1) > W2I(s2)) w
#define	cbranch_int_ge(s1, s2, w)		if (W2I(s1) >= W2I(s2)) w
#define	cbranch_int_ult(s1, s2, w)		if ((unsigned int)W2I(s1) < (unsigned int)W2I(s2)) w

#define	cbranch_int_const_eq(s1, s2, w)		if (W2I(s1) == (s2)) w
#define	cbranch_int_const_ne(s1, s2, w)		if (W2I(s1) != (s2)) w
#define	cbranch_int_const_lt(s1, s2, w)		if (W2I(s1) <  (s2)) w
#define	cbranch_int_const_le(s1, s2, w)		if (W2I(s1) <= (s2)) w
#define	cbranch_int_const_gt(s1, s2, w)		if (W2I(s1) >  (s2)) w
#define	cbranch_int_const_ge(s1, s2, w)		if (W2I(s1) >= (s2)) w
#define	cbranch_int_const_ult(s1, s2, w)	if ((unsigned int)W2I(s1) < (unsigned int)(s2)) w

#define cbranch_ref_eq(s1, s2, w)		if (s1 == s2) w
#define cbranch_ref_ne(s1, s2, w)		if (s1 != s2) w
#define cbranch_ref_const_eq(s1, s2, w)		if (s1 == s2) w
#define cbranch_ref_const_ne(s1, s2, w)		if (s1 != s2) w

#define	call(m) \
  softcall_initialise_class(method_class()); \
  frame->SetPC(-2); frame->SetContPC(npc);        \
  frame->SetTop(frameStackTop);                 \
  UnlockWorker::PushFrame(methodClassLock); \
  return Scheduler::PushCall(closure->ToWord());

#define	call_indirect_method(m)	\
  softcall_initialise_class(method_class());      \
  frame->SetPC(-2); frame->SetContPC(npc);        \
  frame->SetTop(frameStackTop);                   \
  UnlockWorker::PushFrame(methodClassLock); \
  return Scheduler::PushCall(closure->ToWord());

#define	ret()					Scheduler::PopFrame(frame->GetSize()); \
  word* base = (word*) Scheduler::currentTaskStack->GetFrame(0); \
  word* top = base + Scheduler::GetCurrentStackTop() -1; \
  if (base == top) { \
    dprintf("No more FRAMES!!!\n"); \
    /*return Worker::TERMINATE;*/ \
    exit(0); \
  } \
  CHECK_PREEMPT()

#define	returnarg_int(s)			Scheduler::nArgs = 1; Scheduler::currentArgs[0] = s
#define	returnarg_ref(s)			Scheduler::nArgs = 1; Scheduler::currentArgs[0] = s
#define	returnarg_long(s)			Scheduler::nArgs = 2; Scheduler::currentArgs[0] = s
#define	returnarg_float(s)			Scheduler::nArgs = 1; Scheduler::currentArgs[0] = s
#define	returnarg_double(s)			Scheduler::nArgs = 2; Scheduler::currentArgs[0] = s

#define	pusharg_int_const(c, i)			/* Not needed for interpreter */
#define	pusharg_int(f, i)			/* Not needed for interpreter */
#define	pusharg_ref(f, i)			/* Not needed for interpreter */
#define	pusharg_ref_const(f, i)			/* Not needed for interpreter */
#define	pusharg_any(f, i)			/* Not needed for interpreter */
#define	pusharg_anylong(f, i)			/* Not needed for interpreter */
#define	popargs()				/* Not needed for interpreter */

#define	return_int(s)				*(s) = retval
#define	return_long(s)				*(s) = retval
#define	return_float(s)				*(s) = retval
#define	return_double(s)			*(s) = retval
#define	return_ref(s)				*(s) = retval

#define	monitor_enter()				/* Not needed for interpreter */
#define	monitor_exit()				/* Not needed for interpreter */

#define	start_function()			/* Not needed for interpreter */
#define	start_basic_block()			/* Not needed for interpreter */
#define	end_basic_block()			/* Not needed for interpreter */
#define	end_function()				/* Not needed for interpreter */
#define	start_sub_block()			/* Not needed for interpreter */
#define	end_sub_block()				/* Not needed for interpreter */
#define	begin_func_sync()			/* Not needed for interpreter */
#define	end_func_sync()				/* Not needed for interpreter */
#define	begin_sync()				/* Not needed for interpreter */
#define	end_sync()				/* Not needed for interpreter */

#define	set_label(i, l)				label_##i##l:
#define	reference_code_label(l)			npc = (l)
#define	reference_label(i, l)			goto label_##i##l
#define	reference_table_label(l)		&code[npc]
#define	stored_code_label(l)			npc = W2I(*(l))
#define	table_code_label(l)			npc = W2I(*(l)) + pc

#define	load_key(t, f)				*(t) = I2W(\
						 ((((uint8*)Store::WordToUnmanagedPointer(*(f)))[0] << 24) | \
						 (((uint8*)Store::WordToUnmanagedPointer(*(f)))[1] << 16) | \
						 (((uint8*)Store::WordToUnmanagedPointer(*(f)))[2] << 8) | \
						 ((uint8*)Store::WordToUnmanagedPointer(*(f)))[3]))
#define	load_code_ref				load_key

#define	softcall_breakpoint()			ABORT()

#define	move_double(t, f)			*(t) = *(f)
#define	move_double_const(t, c)			*(t) = Double::New(c)->ToWord()
#define	move_float(t, f)			*(t) = *(f)
#define	move_float_const(t, c)			*(t) = Float::New(c)->ToWord()
#define	move_long(t, f)				*(t) = *(f)
#define	move_anylong(t, f)			move_long(t, f)

#define	load_short(t, f)			(t)[0].v.tint = *(jshort*)((f)[0].v.taddr)
#define	load_long(t, f)				(t)[0].v.tlong = *(jlong*)((f)[0].v.taddr)
#define	load_anylong(t, f)			load_long(t, f)
#define	load_float(t, f)			(t)[0].v.tfloat = *(jfloat*)((f)[0].v.taddr)
#define	load_double(t, f)			(t)[0].v.tdouble = *(jdouble*)((f)[0].v.taddr)

#define	store_short(t, f)			*(jshort*)((t)[0].v.taddr) = (W2I(f))
#define	store_long(t, f)			*(jlong*)((t)[0].v.taddr) = ((f)[0].v.tlong)
#define	store_anylong(t, f)			store_long(t, f)
#define	store_float(t, f)			*(jfloat*)((t)[0].v.taddr) = ((f)[0].v.tfloat)
#define	store_double(t, f)			*(jdouble*)((t)[0].v.taddr) = ((f)[0].v.tdouble)

/* XXX: todo */
#define	load_offset_word(t, f, o) {                              \
  Object* object = Object::FromWord(f);                          \
  Assert(object != INVALID_POINTER);                             \
  *(t) = object->GetInstanceField(instanceFieldRef->GetIndex()); \
}
#define	load_offset_int(t, f, o)		load_offset_word(t, f, o)
#define	load_offset_byte(t, f, o)		load_offset_word(t, f, o)
#define	load_offset_char(t, f, o)		load_offset_word(t, f, o)
#define	load_offset_short(t, f, o)		load_offset_word(t, f, o)
#define	load_offset_ref(t, f, o)		load_offset_word(t, f, o)
#define	load_offset_long(t, f, o)		load_offset_word(t, *(f), o)
#define	load_offset_float(t, f, o)		load_offset_word(t, *(f), o)
#define	load_offset_double(t, f, o)		load_offset_word(t, *(f), o)

/* XXX: todo */
#define	store_offset_word(t, o, f)	{                    \
  Object* object = Object::FromWord(t);                      \
  Assert(object != INVALID_POINTER);                         \
  object->PutInstanceField(instanceFieldRef->GetIndex(), f); \
}
#define	store_offset_int(t, o, f)		store_offset_word(*(t), o, *(f))
#define	store_offset_byte(t, o, f)		store_offset_word(*(t), o, *(f))
#define	store_offset_char(t, o, f)		store_offset_word(*(t), o, *(f))
#define	store_offset_short(t, o, f)		store_offset_word(*(t), o, *(f))
#define	store_offset_ref(t, o, f)		store_offset_word(t, o, f)
#define	store_offset_long(t, o, f)		store_offset_word(*(t), o, *(f))
#define	store_offset_float(t, o, f)		store_offset_word(*(t), o, *(f))
#define	store_offset_double(t, o, f)		store_offset_word(*(t), o, *(f))

#define	load_offset_scaled_int(t, b, i, o)	*(t) = I2W(BaseArray::FromWord(b)->LoadInt(W2I(i)))
#define	load_offset_scaled_byte(t, b, i, o)	*(t) = I2W(BaseArray::FromWord(b)->LoadByte(W2I(i)))
#define	load_offset_scaled_char(t, b, i, o)	*(t) = I2W(BaseArray::FromWord(b)->LoadChar(W2I(i)))
#define	load_offset_scaled_short(t, b, i, o)	*(t) = I2W(BaseArray::FromWord(b)->LoadShort(W2I(i)))
#define	load_offset_scaled_ref(t, b, i, o)	*(t) = ObjectArray::FromWord(b)->Load(W2I(i))
#define	load_offset_scaled_long(t, b, i, o)	*(t) = BaseArray::FromWord(*(b))->LoadLong(W2I(*(i)))->ToWord()
#define	load_offset_scaled_float(t, b, i, o)	*(t) = BaseArray::FromWord(*(b))->LoadFloat(W2I(*(i)))->ToWord()
#define	load_offset_scaled_double(t, b, i, o)	*(t) = BaseArray::FromWord(*(b))->LoadDouble(W2I(*(i)))->ToWord()

#define	store_offset_scaled_int(b, i, o, f)	BaseArray::FromWord(b)->StoreInt(W2I(i), W2I(f))
#define	store_offset_scaled_byte(b, i, o, f)	BaseArray::FromWord(b)->StoreByte(W2I(i), W2I(f))
#define	store_offset_scaled_char(b, i, o, f)	BaseArray::FromWord(b)->StoreChar(W2I(i), W2I(f))
#define	store_offset_scaled_short(b, i, o, f)	BaseArray::FromWord(b)->StoreShort(W2I(i), W2I(f))
#define	store_offset_scaled_ref(b, i, o, f)	ObjectArray::FromWord(b)->Store(W2I(i), f)
#define	store_offset_scaled_long(b, i, o, f)	BaseArray::FromWord(*(b))->StoreLong(W2I(*(i)), JavaLong::FromWord(*(f)))
#define	store_offset_scaled_float(b, i, o, f)	BaseArray::FromWord(*(b))->StoreFloat(W2I(*(i)), JavaFloat::FromWord(*(f)))
#define	store_offset_scaled_double(b, i, o, f)	BaseArray::FromWord(*(b))->StoreDouble(W2I(*(i)), JavaDouble::FromWord(*(f)))

#define	load_addr_word(t, a) {                                         \
  *(t) = fieldClass->GetStaticField(staticFieldRef->GetIndex()); \
  fieldClassLock->Release();                                     \
}
#define	load_addr_int(t, a)	load_addr_word(t, a)
#define	load_addr_byte(t, a)	load_addr_word(t, a)
#define	load_addr_char(t, a)	load_addr_word(t, a)
#define	load_addr_short(t, a)	load_addr_word(t, a)
#define	load_addr_ref(t, a)	load_addr_word(t, a)
#define	load_addr_long(t, a)	load_addr_word(t, a)
#define	load_addr_float(t, a)	load_addr_word(t, a)
#define	load_addr_double(t, a)	load_addr_word(t, a)

#define	store_addr_word(a, f)	{                                     \
  fieldClass->PutStaticField(staticFieldRef->GetIndex(), *(f)); \
  fieldClassLock->Release();                                    \
}
#define	store_addr_int(a, f)	store_addr_word(a, f)
#define	store_addr_byte(a, f)	store_addr_word(a, f)
#define	store_addr_char(a, f)	store_addr_word(a, f)
#define	store_addr_short(a, f)	store_addr_word(a, f)
#define	store_addr_ref(a, f)	store_addr_word(a, f)
#define	store_addr_long(a, f)	store_addr_word(a, f)
#define	store_addr_float(a, f)	store_addr_word(a, f)
#define	store_addr_double(a, f)	store_addr_word(a, f)


#define	add_float(t, f1, f2)			*(t) = F2W(W2F(f1) + W2F(f2))
#define	add_double(t, f1, f2)			*(t) = D2W(W2D(f1) + W2D(f2))
#define	sub_float(t, f1, f2)			*(t) = F2W(W2F(f1) - W2F(f2))
#define	sub_double(t, f1, f2)			*(t) = D2W(W2D(f1) - W2D(f2))
#define	mul_float(t, f1, f2)			*(t) = F2W(W2F(f1) * W2F(f2))
#define	mul_double(t, f1, f2)			*(t) = D2W(W2D(f1) * W2D(f2))
#define	div_float(t, f1, f2)			*(t) = F2W(W2F(f1) / W2F(f2))
#define	div_double(t, f1, f2)			*(t) = D2W(W2D(f1) / W2D(f2))
#define	rem_float(t, f1, f2)			*(t) = F2W(javaRemainderf(W2F(f1), W2F(f2)))
#define	rem_double(t, f1, f2)			*(t) = D2W(javaRemainder(W2D(f1), W2D(f2)))
#define	neg_float(t, f)				*(t) = F2W(-(W2F(f)))
#define	neg_double(t, f)			*(t) = D2W(-(W2D(f)))

#define	cmpg_float(t, f1, f2)			*(t) = I2W(soft_fcmpg(W2F(*(f1)), W2F(*(f2))))
#define	cmpg_double(t, f1, f2)			*(t) = I2W(soft_dcmpg(W2D(*(f1)), W2D(*(f2))))
#define	cmpl_float(t, f1, f2)			*(t) = I2W(soft_fcmpl(W2F(*(f1)), W2F(*(f2))))
#define	cmpl_double(t, f1, f2)			*(t) = I2W(soft_dcmpl(W2D(*(f1)), W2D(*(f2))))

#define	cvt_int_float(t, f)			*(t) = F2W(W2I(*(f)))
#define	cvt_int_double(t, f)			*(t) = D2W(W2I(*(f)))
#define	cvt_float_int(t, f)			*(t) = I2W(soft_cvtfi(W2F(*(f))))
#define	cvt_float_double(t, f)			*(t) = D2W(W2F(*(f)))
#define	cvt_double_int(t, f)			*(t) = I2W(soft_cvtdi(W2D(*(f))))
#define	cvt_double_float(t, f)			*(t) = F2W(W2D(*(f)))

/* XXX: todo */
#define	softcall_lookupinterfacemethod(r, n, t)	/*(r)[0].v.taddr = soft_lookupinterfacemethod((t)[0].v.taddr, (n)->class, (n)->idx)*/
#define	softcall_new(r, t) {			 \
  Class *aClass = STATIC_CAST(Class *, t->type); \
  Lock *lock = aClass->GetLock();                \
  Future *future = lock->Acquire();              \
  if (future != INVALID_POINTER) {               \
    pop(1);                                      \
    REQUEST(future->ToWord());                   \
  }                                              \
  if (!aClass->IsInitialized()) {                \
    pop(1);                                      \
    frame->SetPC(pc);                            \
    frame->SetTop(frameStackTop);                \
    return aClass->RunInitializer();             \
  }                                              \
  Object *object = Object::New(aClass);          \
  Assert(object != INVALID_POINTER);             \
  *(r) = object->ToWord();                       \
  lock->Release();                               \
}

#define	softcall_newarray(r, s, t) {                           \
  s_int count = JavaInt::FromWord(*(s));                       \
  BaseArray *baseArray;                                        \
  switch (t) {                                                 \
  case 4:                                                      \
    baseArray = BaseArray::New(PrimitiveType::Boolean, count); \
    break;                                                     \
  case 5:                                                      \
    baseArray = BaseArray::New(PrimitiveType::Char, count);    \
    break;                                                     \
  case 6:                                                      \
    baseArray = BaseArray::New(PrimitiveType::Float, count);   \
    break;                                                     \
  case 7:                                                      \
    baseArray = BaseArray::New(PrimitiveType::Double, count);  \
    break;                                                     \
  case 8:                                                      \
    baseArray = BaseArray::New(PrimitiveType::Byte, count);    \
    break;                                                     \
  case 9:                                                      \
    baseArray = BaseArray::New(PrimitiveType::Short, count);   \
    break;                                                     \
  case 10:                                                     \
    baseArray = BaseArray::New(PrimitiveType::Int, count);     \
    break;                                                     \
  case 11:                                                     \
    baseArray = BaseArray::New(PrimitiveType::Long, count);    \
    break;                                                     \
  default:                                                     \
    Error("invalid base type");                                \
  }                                                            \
  *(r) = baseArray->ToWord();                                  \
}
#define	softcall_anewarray(r, s, t)		/*(r)->v.taddr = soft_anewarray(t, (s)->v.tint)*/
#define	softcall_athrow(s)			/*soft_athrow((Hjava_lang_Object*)((s)[0].v.taddr))*/
#define	softcall_checkcast(n, o, t)		/*soft_checkcast(t, (Hjava_lang_Object*)((o)->v.taddr))*/
#define softcall_initialise_class(cl)		if (!cl->IsInitialized()) { frame->SetPC(pc); frame->SetTop(frameStackTop); return cl->RunInitializer(); }
#define	softcall_instanceof(r, o, t)		/*(r)->v.tint = soft_instanceof(t, (Hjava_lang_Object*)((o)->v.taddr))*/

/* XXX: todo */
#define	softcall_monitorenter(o)		/*lockObject((o)[0].v.taddr)*/
#define	softcall_monitorexit(o)			/*unlockObject((o)[0].v.taddr)*/

/* XXX: todo */
#define	softcall_multianewarray(r, z, s, t)	/*(r)->v.taddr = soft_multianewarray(t, z, s); \
                                                  pop((z) - 1)*/

#define	softcall_badarrayindex()		soft_badarrayindex()
#define	softcall_nullpointer()			soft_nullpointer()
#define	softcall_nosuchmethod(c,n,s)		/*soft_nosuchmethod(c,n,s)*/
#define	softcall_nosuchfield(c,n)		soft_nosuchfield(c,n)
#define	softcall_linkage(c,n)			soft_linkage(c,n)
#define	softcall_illegalaccess(c,n)		soft_illegalaccess(c,n)
/* XXX: todo */
#define	softcall_nosuchclass(c)			/*soft_nosuchclass(c)*/

#define	softcall_checkarraystore(a, o)		soft_checkarraystore((Hjava_lang_Object*)((a)[0].v.taddr), (Hjava_lang_Object*)((o)[0].v.taddr))
#define	softcall_addreference(f, t)		soft_addreference((f)[0].v.taddr, (t)[0].v.taddr)
#define	softcall_addreference_static(f, t)	soft_addreference((f), (t)[0].v.taddr)
#define softcall_incompatibleclasschange(a,b)	soft_incompatibleclasschange(a,b)

#define	adjustpc(a)				/* Not needed for interpreter */

/* XXX: todo */
#define	check_array_index(O, I)			if (JavaInt::FromWord(I) >= (int) ARRAY_SIZE(O)) { \
						  Error("Bas array index exception not implemented yet!\n"); \
						  soft_badarrayindex(); \
                                                }
#define	build_call_frame(SIG, OBJ, NRARGS)	/* Not needed for interpreter */













// stack accessors:
// pushing N entries to stack
#ifdef push
#undef push
#endif
#define	push(N)			(frameStackTop += (N))
// popping N entries from stack
#ifdef pop
#undef pop
#endif
#define	pop(N)			(frameStackTop -= (N))

// access the Nth topmost stack element as reference
#ifdef stack
#undef stack
#endif
#define	stack(N)		(frameStackBase - (frameStackTop - (N) - 1))
// longs and doubles are accessed the same way for kaffe/SEAM
#ifdef stack_long
#undef stack_long
#endif
#define	stack_long(N)           stack((N)+1)


// access the Nth topmost stack element as RValue
#ifdef rstack
#undef rstack
#endif
#define	rstack(N)		(*(stack(N)))
// all other data types are accessed the same way in kaffe/SEAM
#ifdef rstack_ref
#undef rstack_ref
#endif
#define	rstack_ref		rstack
#ifdef rstack_long
#undef rstack_long
#endif
#define	rstack_long(N)		rstack((N)+1)
#ifdef rstack_float
#undef rstack_float
#endif
#define	rstack_float		rstack
#ifdef rstack_double
#undef rstack_double
#endif
#define	rstack_double		rstack_long

// access the Nth local variable as reference
#ifdef local
#undef local
#endif
#define	local(N)		(frameStackBase - KaffeFrame::BASE_SIZE - (N))



// current_class gives pointer to the Object of the running method
// XXX: todo!!!
#define current_class() NULL

// CLASS_CONST_DATA gives the data of ConstantPool Tag for the given
// index of the given class
#ifdef CLASS_CONST_DATA
#undef CLASS_CONST_DATA
#endif
// XXX: what if cls is not the current_class?
// answer: in all kaffe code, cls is always the current_class
#define CLASS_CONST_DATA(cls,idx) (pool->Get(idx))

// CLASS_CONST_LONG gives the Long at ConstantPool Tag for the given
// index of the given class
#ifdef CLASS_CONST_LONG
#undef CLASS_CONST_LONG
#endif
#define CLASS_CONST_LONG(cls,idx) (JavaLong::FromWord(CLASS_CONST_DATA(cls,idx))->GetValue())

// CLASS_CONST_DOUBLE gives the Double at ConstantPool Tag for the given
// index of the given class
#ifdef CLASS_CONST_DOUBLE
#undef CLASS_CONST_DOUBLE
#endif
#define CLASS_CONST_DOUBLE(cls,idx) (JavaDouble::FromWord(CLASS_CONST_DATA(cls,idx))->GetValue())

// ARRAY_SIZE gives the length of the given array
#ifdef ARRAY_SIZE
#undef ARRAY_SIZE
#endif
// XXX: need more efficient implementation!
#define ARRAY_SIZE(A) ((Store::WordToBlock(A)->GetLabel() == JavaLabel::ObjectArray) ? \
                       ObjectArray::FromWordDirect(A)->GetLength()   : \
                       BaseArray::FromWordDirect(A)->GetLength())

/* Class state */
typedef enum {
        CSTATE_FAILED = -1,
        CSTATE_UNLOADED,
        CSTATE_LOADED,
        CSTATE_LOADED_SUPER,
        CSTATE_PRELOADED,
        CSTATE_VERIFIED,
        CSTATE_DOING_PREPARE,
        CSTATE_PREPARED,
        CSTATE_DOING_LINK,
        CSTATE_LINKED,
        CSTATE_CONSTINIT,
        CSTATE_DOING_SUPER,
        CSTATE_USABLE,
        CSTATE_DOING_INIT,
        CSTATE_COMPLETE
} class_state_t;

// this is the "class" struct as needed by kaffe, reduced to the used
// accessors in kaffe/SEAM
typedef struct Hjava_lang_Class {
	Utf8Const*		name;
	accessFlags		accflags;
	short			msize;
	void*			dtable;
	class_state_t		state;

  // additional members needed for kaffe/SEAM
  // the type of the represented class
  Type* type;
  // the jvm-seam class object
  Class* jvms_cls;
} Hjava_lang_Class;


// this is the "method" struct as needed by kaffe, reduced to the used
// accessors in kaffe/SEAM
typedef struct _methods {
	Utf8Const*		name;
	accessFlags		accflags;
	long			idx;	/* Index into class->dtable */
	u2			stacksz;
	u2			localsz;
	/* Only used for static/final/constructor methods */
	void*   		ncode;
	Hjava_lang_Class*	cls;
} methods;

// this is the "callInfo" struct as needed by kaffe, reduced to the used
// accessors in kaffe/SEAM
typedef struct _callInfo {
        Class*       cls;
        word                 method;
        short                   in;
        short                   out;
        Utf8Const*             cname;
        Utf8Const*             name;
        Utf8Const*             signature;
        char                    rettype;
} callInfo;

// this is the "fields" struct as needed by kaffe, reduced to the used
// accessors in kaffe/SEAM
typedef struct _fields {
	Hjava_lang_Class*	clazz;
	Utf8Const*		name;
	Utf8Const*		signature;
	Hjava_lang_Class*	type;
	accessFlags		accflags;
	u2			bsize;		/* in bytes */
	union {
		int		boffset;	/* offset in bytes (object) */
		void*		addr;		/* address (static) */
		u2		idx;		/* constant value index */
	} info;

  word jvms_fieldref;
} fields;

// this is the "fieldInfo" struct as needed by kaffe, reduced to the used
// accessors in kaffe/SEAM
typedef struct _fieldInfo {
        word                  field;
        Class*                cls;
        Utf8Const*             cname;
        Utf8Const*             name;
        Utf8Const*             signature;
} fieldInfo;


/* Type of field FLD.  Only valid if FIELD_RESOLVED(FLD). */
#define FIELD_TYPE(FLD)         (field_is_static(FLD) ? StaticFieldRef::FromWord(FLD)->GetDescriptor()   \
                                                      : InstanceFieldRef::FromWord(FLD)->GetDescriptor())

// FIELD_BOFFSET(FLD) expands to FLD itself as we do not use the byte offset
// paradigm of kaffe but method invocation on the field object and need the
// filed itself therefor
#define FIELD_BOFFSET(FLD)      (FLD)
// a field is primitive iff the first letter in its descriptor is not a '[' nor a 'L'
#define FIELD_ISPRIM(FLD)       ((FIELD_TYPE(FLD)->CharAt(0) != '[') && (FIELD_TYPE(FLD)->CharAt(0) != 'L'))
// XXX: to be checked!
#define FIELD_ISREF(FLD)        (!FIELD_ISPRIM(FLD) && FIELD_TYPE(FLD) != PtrClass)

#define _PRIMITIVE_DTABLE ((struct _dispatchTable*)(-1))
#define CLASS_IS_PRIMITIVE(CL) ((CL)->dtable == _PRIMITIVE_DTABLE)
/* Assuming CLASS_IS_PRIMITIVE(CL), return the 1-letter signature code. */
#define CLASS_PRIM_SIG(CL) (CL->CharAt(0))



/* -------------------------------------------------------------------- */
/* Fields */
/* -------------------------------------------------------------------- */
#ifdef field_is_static
#undef field_is_static
#endif
#define field_is_static(f) (StaticFieldRef::IsValid(f))

/* XXX: todo */
#ifdef field_is_final
#undef field_is_final
#endif
#define field_is_final(f) (false)

#ifdef get_static_field_info_noerror
#undef get_static_field_info_noerror
#endif
#define	get_static_field_info_noerror(IDX) get_static_field_info(IDX)

#ifdef get_static_field_info
#undef get_static_field_info
#endif
#define	get_static_field_info(IDX) {                              \
  word wFieldRef = pool->Get(idx);                                \
  staticFieldRef = StaticFieldRef::FromWord(wFieldRef);           \
  if (staticFieldRef == INVALID_POINTER) {                        \
    dprintf("StaticFieldRef, ");                                  \
    REQUEST(wFieldRef);                                           \
  }                                                               \
  fieldClass = staticFieldRef->GetClass();                        \
  Assert(fieldClass != INVALID_POINTER);                          \
  fieldClassLock = fieldClass->GetLock();                         \
  Future* future = fieldClassLock->Acquire();                     \
  if (future != INVALID_POINTER) {                                \
    dprintf("StaticFieldRef's Lock-Future, ");                    \
    REQUEST(future->ToWord());                                    \
  }                                                               \
  finfo.field = wFieldRef;                                        \
  finfo.cls = fieldClass;                                         \
}

#ifdef get_field_info
#undef get_field_info
#endif
#define	get_field_info(IDX) {                                     \
  word wFieldRef = pool->Get(idx);                                \
  instanceFieldRef = InstanceFieldRef::FromWord(wFieldRef);       \
  if (instanceFieldRef == INVALID_POINTER) {                      \
    dprintf("InstanceFieldRef, ");                                \
    REQUEST(wFieldRef);                                           \
  }                                                               \
  finfo.field = wFieldRef;                                        \
}


#define load_arraylength(dst,src) {                               \
  Block* p = Store::WordToBlock(src);                             \
  if (p != INVALID_POINTER) {                                     \
    u_int length;                                                 \
    switch (p->GetLabel()) {                                      \
    case JavaLabel::BaseArray:                                    \
      length = STATIC_CAST(BaseArray *, p)->GetLength();          \
      break;                                                      \
    case JavaLabel::ObjectArray:                                  \
      length = STATIC_CAST(ObjectArray *, p)->GetLength();        \
      break;                                                      \
    default:                                                      \
      Error("unkown type");                                       \
    }                                                             \
    *(dst) = I2W(length);                                         \
  }                                                               \
  else {                                                          \
    RAISE_VM_EXCEPTION(NullPointerException, "ARRAYLENGTH");      \
  }                                                               \
}

/* -------------------------------------------------------------------- */
/* Methods */
/* -------------------------------------------------------------------- */
#ifdef method_is_static
#undef method_is_static
#endif
#define method_is_static(m) (StaticMethodRef::IsValid(m))

// XXX: todo!
#ifdef method_is_constructor
#undef method_is_constructor
#endif
#define method_is_constructor(m) (false)

// XXX: todo!
#ifdef method_is_virtual
#undef method_is_virtual
#endif
#define method_is_virtual(m) (false)

#ifdef get_static_method_info
#undef get_static_method_info
#endif
#define	get_static_method_info(IDX) {                              \
  word wMethodRef = pool->Get(idx);                                \
  staticMethodRef = StaticMethodRef::FromWord(wMethodRef);         \
  if (staticMethodRef == INVALID_POINTER) {                        \
    dprintf("StaticMethodRef, ");                                  \
    REQUEST(wMethodRef);                                           \
  }                                                                \
  methodClass = staticMethodRef->GetClass();                       \
  Assert(methodClass != INVALID_POINTER);                          \
  methodClassLock = methodClass->GetLock();                        \
  Future* future = methodClassLock->Acquire();                     \
  if (future != INVALID_POINTER) {                                 \
    dprintf("StaticMethodRef's Lock-Future, ");                    \
    REQUEST(future->ToWord());                                     \
  }                                                                \
  if (!methodClass->IsInitialized()) {                             \
    dprintf("StaticMethodRef running initializer.\n");             \
    frame->SetPC(pc);                                              \
    frame->SetTop(frameStackTop);                                  \
    return methodClass->RunInitializer();                          \
  }                                                                \
  cinfo.method = wMethodRef;                                       \
  cinfo.cls = methodClass;                                         \
  cinfo.in = staticMethodRef->GetNumberOfArguments();              \
}

#ifdef get_special_method_info
#undef get_special_method_info
#endif
#define	get_special_method_info(IDX) {                             \
  word wMethodRef = pool->Get(idx);                                \
  virtualMethodRef = VirtualMethodRef::FromWord(wMethodRef);       \
  if (virtualMethodRef == INVALID_POINTER) {                       \
    dprintf("VirtualMethodRef, ");                                 \
    REQUEST(wMethodRef);                                           \
  }                                                                \
  methodClass = virtualMethodRef->GetClass();                      \
  Assert(methodClass != INVALID_POINTER);                          \
  methodClassLock = methodClass->GetLock();                        \
  Future* future = methodClassLock->Acquire();                     \
  if (future != INVALID_POINTER) {                                 \
    dprintf("VirtualMethodRef's Lock-Future, ");                   \
    REQUEST(future->ToWord());                                     \
  }                                                                \
  if (!methodClass->IsInitialized()) {                             \
    dprintf("VirtualMethodRef running initializer.\n");            \
    frame->SetPC(pc);                                              \
    frame->SetTop(frameStackTop);                                  \
    return methodClass->RunInitializer();                          \
  }                                                                \
  cinfo.method = wMethodRef;                                       \
  cinfo.cls = methodClass;                                         \
  cinfo.in = virtualMethodRef->GetNumberOfArguments();             \
}

// XXX: todo!!!
#ifdef get_interface_method_info
#undef get_interface_method_info
#endif
#define	get_interface_method_info(IDX) {                           \
  word wMethodRef = pool->Get(idx);                                \
  virtualMethodRef = VirtualMethodRef::FromWord(wMethodRef);       \
  if (virtualMethodRef == INVALID_POINTER) {                       \
    dprintf("VirtualMethodRef, ");                                 \
    REQUEST(wMethodRef);                                           \
  }                                                                \
  methodClass = virtualMethodRef->GetClass();                      \
  Assert(methodClass != INVALID_POINTER);                          \
  methodClassLock = methodClass->GetLock();                        \
  Future* future = methodClassLock->Acquire();                     \
  if (future != INVALID_POINTER) {                                 \
    dprintf("VirtualMethodRef's Lock-Future, ");                   \
    REQUEST(future->ToWord());                                     \
  }                                                                \
  if (!methodClass->IsInitialized()) {                             \
    dprintf("VirtualMethodRef running initializer.\n");            \
    frame->SetPC(pc);                                              \
    frame->SetTop(frameStackTop);                                  \
    return methodClass->RunInitializer();                          \
  }                                                                \
  cinfo.method = wMethodRef;                                       \
  cinfo.cls = methodClass;                                         \
  cinfo.in = virtualMethodRef->GetNumberOfArguments();             \
}

#ifdef get_method_info
#undef get_method_info
#endif
#define	get_method_info(IDX) {                             \
  word wMethodRef = pool->Get(idx);                                \
  virtualMethodRef = VirtualMethodRef::FromWord(wMethodRef);       \
  if (virtualMethodRef == INVALID_POINTER) {                       \
    dprintf("VirtualMethodRef, ");                                 \
    REQUEST(wMethodRef);                                           \
  }                                                                \
  methodClass = virtualMethodRef->GetClass();                      \
  Assert(methodClass != INVALID_POINTER);                          \
  methodClassLock = methodClass->GetLock();                        \
  Future* future = methodClassLock->Acquire();                     \
  if (future != INVALID_POINTER) {                                 \
    dprintf("VirtualMethodRef's Lock-Future, ");                   \
    REQUEST(future->ToWord());                                     \
  }                                                                \
  if (!methodClass->IsInitialized()) {                             \
    dprintf("VirtualMethodRef running initializer.\n");            \
    frame->SetPC(pc);                                              \
    frame->SetTop(frameStackTop);                                  \
    return methodClass->RunInitializer();                          \
  }                                                                \
  cinfo.method = wMethodRef;                                       \
  cinfo.cls = methodClass;                                         \
  cinfo.in = virtualMethodRef->GetNumberOfArguments();             \
}

#ifdef METHOD_TRANSLATED
#undef METHOD_TRANSLATED
#endif
#define METHOD_TRANSLATED(M)		(true)

// XXX: todo?
#ifdef METHOD_NATIVECODE
#undef METHOD_NATIVECODE
#endif
#define	METHOD_NATIVECODE(M)		(false)

#ifdef build_call_frame
#undef build_call_frame
#endif
#define	build_call_frame(SIG, OBJ, NRARGS)                           \
  Closure* closure;                                                  \
{                                                                    \
  int nrargs = NRARGS + ((OBJ) ? 1 : 0);                             \
  Assert(nrargs < (int) Scheduler::maxArgs);                         \
  Scheduler::nArgs = nrargs;                                         \
  for (int i = nrargs; i--;) {                                       \
    Scheduler::currentArgs[i] = rstack((nrargs-(i+1)));              \
  }                                                                  \
  if (!OBJ) {                                                        \
    closure =                                                        \
    methodClass->GetStaticMethod(staticMethodRef->GetIndex());       \
  } else {                                                           \
    closure =                                                        \
    methodClass->GetVirtualMethod(virtualMethodRef->GetIndex());     \
  }                                                                  \
}

/* -------------------------------------------------------------------- */
/* Classes */
/* -------------------------------------------------------------------- */
// XXX: todo?
#ifdef method_from_class
#undef method_from_class
#endif
#define method_from_class(m,c) (true)

#ifdef class_uninitialized
#undef class_uninitialized
#endif
#define class_uninitialized(c) (!(c)->IsInitialized())

// XXX: todo?
#ifdef class_is_interface
#undef class_is_interface
#endif
#define class_is_interface(c) (false)

#ifdef get_class_info
#undef get_class_info
#endif
#define	get_class_info(idx) {                        \
  word wType = pool->Get(idx);                       \
  Type* type = Type::FromWord(wType);                \
  if (type == NULL) {                                \
    dprintf("Type, ");                               \
    REQUEST(wType);                                  \
  } else {                                           \
    crinfo = &class_struct;                          \
    crinfo->type = type;                             \
  }                                                  \
}

#define	class_object()		(crinfo)

// class_name gives the name of the class at given ConstantPool index
#ifdef class_name
#undef class_name
#endif
#define class_name(idx) (JavaString::FromWordDirect(pool->Get(idx)))


#define CONSTANT_ResolvedString 8 //CONSTANT_tag::CONSTANT_String

#ifdef resolveString
#undef resolveString
#endif
#define resolveString(cls,idx,ei) ((void*)CLASS_CONST_DATA(cls,idx))

// XXX: todo!!!
#ifdef throwError
#undef throwError
#endif
#define throwError(ei)

#ifdef ABORT
#undef ABORT
#endif
#define ABORT() Assert("abort called" == NULL)

// XXX: todo!
// int checkFieldAccess(Hjava_lang_Class *context,
//                      Hjava_lang_Class *target,
//                      Field *field);
#define checkFieldAccess(context_cls,target_cls,field) true

// XXX: todo!
// int checkMethodAccess(Hjava_lang_Class *context,
//                       Hjava_lang_Class *target,
//                       Method *method);
#define checkMethodAccess(context_cls,target_cls,method) true

// method invocation
#define OBJECT_DTABLE_OFFSET 0
#define DTABLE_METHODOFFSET 0
#define DTABLE_METHODSIZE 0

// constant resolving, part one: what type of const is it?
#define CLASS_CONST_TAG(cls,idx) (pool->GetTypeInfo(idx)->GetTag())

#ifdef CONSTANT_String
#undef CONSTANT_String
#endif
#define CONSTANT_String -1

#define	move_int_const_word(t, c) *(t) = (c)
#define	move_float_const_word(t, c) *(t) = (c)
#define	move_long_const_word(t, c) *(t) = (c)
#define	move_double_const_word(t, c) *(t) = (c)

#ifdef EXIT
#undef EXIT
#endif
#define EXIT() std::exit(1)

#ifdef DBG
#undef DBG
#endif
#define DBG(mask, statement) statement

#ifdef dprintf
#undef dprintf
#endif
#ifdef JAVA_INTERPRETER_DEBUG
#  define dprintf printf
#else
#  define dprintf(s,...)
#endif

#ifdef monitor_enter
#undef monitor_enter
#endif
#define	monitor_enter() dprintf("\nmonitor_enter() NOT implemented yet!\n\n");
#ifdef monitor_exit
#undef monitor_exit
#endif
#define	monitor_exit() \
  /* make sure, Scheduler::nArgs is set reasonable */         \
  /* (RETURN does not set it otherwise!)           */         \
  Scheduler::nArgs = 0;                                       \
  dprintf("\nmonitor_exit() NOT implemented yet!\n\n");

#include "kaffe-soft.c"


#endif
