//
// Authors:
//   Patrick Cernko <cernko@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/03/16 07:56:47 $ by $Author: errror $
//   $Revision: 1.1.2.3 $
//
#ifndef __JAVA__KAFFE_INTERPRETER_HH__
#define __JAVA__KAFFE_INTERPRETER_HH__

#if defined(INTERFACE)
#pragma interface "java/KaffeInterpreter.hh"
#endif

#include "Seam.hh"
#include "java/Base.hh"
#include "java/Data.hh"
#include "java/Opcodes.hh"

class JavaDll KaffeInterpreter 
  : public Interpreter,
    private Instr {
private:
  KaffeInterpreter() : Interpreter() {}
public:
  static KaffeInterpreter *self;

  static void Init();

  virtual Transform *GetAbstractRepresentation(ConcreteRepresentation *);

  virtual u_int GetFrameSize(StackFrame *sFrame);
  virtual Result Run(StackFrame *sFrame);
  virtual Result Handle(word data);
  virtual u_int GetInArity(ConcreteCode *concreteCode);
  virtual u_int GetOutArity(ConcreteCode *concreteCode);
  virtual void PushCall(Closure *closure);
  virtual const char *Identify();
  virtual void DumpFrame(StackFrame *sFrame);

  //--** move this to the JavaLanguageLayer?:
  static void FillStackTraceElement(word wFrame, Object *stackTraceElement);
};

#endif
